# AITom

## Introduction
AITom is an open-source platform for AI driven cellular electron cryo-tomography analysis. 

AITom is originated from the tomominer library, adapted from an [extended version](http://web.cmb.usc.edu/people/alber/Software/mpp/) of the [tomominer library](https://github.com/alberlab/tomominer), developed at [Alber Lab](http://web.cmb.usc.edu/people/alber/).


## [Tutorials](https://github.com/xulabs/aitom_doc/tree/master/tutorials)

## [Install](https://github.com/xulabs/aitom/blob/master/doc/install.md)

# About us
## Xulab at Carnegie Mellon University Computational Biology Department
Code and data for projects developed and maintained by [Xu Lab](https://cs.cmu.edu/~mxu1) and [collaborators](https://github.com/xulabs/aitom/blob/master/doc/collaborators.md). 

The research related to the code and data can be found at http://cs.cmu.edu/~mxu1

### Background
Nearly every major process in a cell is orchestrated by the interplay of macromolecular assemblies, which often coordinate their actions as functional modules in biochemical pathways.  To proceed efficiently,  this  interplay  between  different macromolecular  machines  often  requires  a  distinctly nonrandom spatial organization in the cell. With the recent revolutions in cellular Cryo-Electron Tomography (Cryo-ET) imaging technologies, it is now possible to generate 3D reconstructions of cells in hydrated, close to native states at submolecular resolution. 


### Research
We are developing computational analysis techniques for processing large amounts of Cryo-ET data to reconstruct, detect, classify, recover, and spatially model different cellular components. We utilize state-of-the-art machine learning (including deep learning) approaches to design Cryo-ET specific data analysis and modeling algorithms. Our research automates the cellular structure discovery and will lead to new insights into the basic molecular biology and medical applications.


<img src="https://user-images.githubusercontent.com/31047726/51266413-3613ec00-1989-11e9-810f-f8cb4924f435.png">

*De novo* structural mining pipeline results: (a). A slice of a [rat neuron tomogram](https://doi.org/10.1016/j.cell.2017.12.030),  (b). Recovered patterns (from left to right): mitochondrial membrane, Ribosome-like pattern, ellipsoid of strong signals, TRiC-like pattern, borders of ice crystal, (c). Pattern mining results embedded, (d). Individual patterns embedded.

### [Cite AITom](https://github.com/xulabs/aitom/blob/master/doc/cite.md)

### [Funding](https://github.com/xulabs/aitom/blob/master/doc/funding.md)
